    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import org.apache.bcel.Constants;
    58  import java.io.*;
    59
    60  /***
    61   * This class is derived from the abstract
    62   * <A HREF="org.apache.bcel.classfile.Constant.html">Constant</A> class
    63   * and represents a reference to a float object.
    64   *
    65   * @version $Id: ConstantFloat.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     Constant
    68   */
    69  public final class ConstantFloat extends Constant implements ConstantObject {
    70    private float bytes;
    71
    72    /***
    73     * @param bytes Data
    74     */
    75    public ConstantFloat(float bytes)
    76    {
    77      super(Constants.CONSTANT_Float);
    78      this.bytes = bytes;
    79    }
    80    /***
    81     * Initialize from another object. Note that both objects use the same
    82     * references (shallow copy). Use clone() for a physical copy.
    83     */
    84    public ConstantFloat(ConstantFloat c) {
    85      this(c.getBytes());
    86    }
    87    /***
    88     * Initialize instance from file data.
    89     *
    90     * @param file Input stream
    91     * @throws IOException
    92     */
    93    ConstantFloat(DataInputStream file) throws IOException
    94    {
    95      this(file.readFloat());
    96    }
    97    /***
    98     * Called by objects that are traversing the nodes of the tree implicitely
    99     * defined by the contents of a Java class. I.e., the hierarchy of methods,
    100    * fields, attributes, etc. spawns a tree of objects.
    101    *
    102    * @param v Visitor object
    103    */
    104   public void accept(Visitor v) {
    105     v.visitConstantFloat(this);
    106   }
    107   /***
    108    * Dump constant float to file stream in binary format.
    109    *
    110    * @param file Output file stream
    111    * @throws IOException
    112    */
    113   public final void dump(DataOutputStream file) throws IOException
    114   {
    115     file.writeByte(tag);
    116     file.writeFloat(bytes);
    117   }
    118   /***
    119    * @return data, i.e., 4 bytes.
    120    */
    121   public final float getBytes() { return bytes; }
    122   /***
    123    * @param bytes.
    124    */
    125   public final void setBytes(float bytes) {
    126     this.bytes = bytes;
    127   }
    128
    129   /***
    130    * @return String representation.
    131    */
    132   public final String toString() {
    133     return super.toString() + "(bytes = " + bytes + ")";
    134   }
    135
    136   /*** @return Float object
    137    */
    138   public Object getConstantValue(ConstantPool cp) {
    139     return new Float(bytes);
    140   }
    141 }

This page was automatically generated by Maven